import { combineReducers } from 'redux'


const sensorReducer = (state = [], action) => {
  switch (action.type) {
    case "ADD_SENSOR":
      return [
        ...state,
        {
          id: action.id,
          sensor: action.sensor
        }
      ]

    case "ADD_VALUE":

      let ret = [];

      for(let i=0; i<state.length; i++){
        if(state[i].id === action.id){
          state[i].sensor.value = action.value;
        }
        ret.push(state[i]);
      }

      return ret;
    default: return state;
  }
}

const menuReducer = (state = [], action) => {
  switch(action.type){
    case 'ADD_MENU':
      return [
        ...state,
        {
          name: action.name,
          url: action.url
        }
      ]
    default:
      return state;
  }
}

const reducer = combineReducers({
  sensorReducer,
  menuReducer
})

export default reducer;
